<?php

abstract class AbstractController {
  protected function __contructor () {
    
  }
  
  public function default_method () {
    echo "<h1>It Works!</h1>";
  }
  
  /**
   * This should return a list of method names.
   * 
   * @code{.php}
    function get_methods () {
      $ret_val = [
        "method_one",
        "method_two",
        ...
      ];
      
      return ret_val;
    }
   * @endcode
   */
  abstract public function get_methods ();
  
  /**
   * Get the custom rout definitions.
   */
  abstract public function get_routes ();
  
  /**
   * load a view class.
   */
  public function load_view ($view, $user_data) {
    require (ROOT_DIR . "View" . DS . $view . ".php");
    $$view = new $view ();
    $$view->render ($user_data);
  }
  
  /**
   * Returns a model object
   */
  public function load_model ($model) {
    require (ROOT_DIR . "Model" . DS . $model . ".php");
    $$model = new $model ();
    
    return $$model;
  }
  
}
